/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* This software is public domain. Permission is granted to     *
* use, copy and modify this software to anyone.                *
****************************************************************
* Please don't contact me for information, bugs, comments, job *
* offers. If you like this software, please send a postcard to *
* the following address:                                       *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA                                                      *
****************************************************************
* The author is not liable for damages resulting from  the use *
* of this software or its derivates.                           *
\**************************************************************/

import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.util.*;
import java.awt.*;

public class VasSpyApplet extends Applet {
  //decodes a www-url-encoded string to it's normal form
  //such kind of string has '+' instead of ' ' and
  //"% + hexa values" of caracters different from a-Z_0-9
  //for example ':' will be "%3A"
  /*
    encoded string:
    http://127.0.0.1/New%20%2b%20Folder%20-'Best%20of%20%20all'%20%26%20cute/SecondTest.html
    decoded one:
    http://127.0.0.1/New + Folder -'Best of  all' & cute/SecondTest.html
  */
  private String decodeURL(String s) {
    if(s==null) return "";
    int i=0;
    StringBuffer worked=new StringBuffer();
    while(i<s.length()) {
      char c=s.charAt(i);
      if(c=='%' && i<s.length()-2) {
        try {
          c=(char)Integer.parseInt(s.substring(i+1, i+3), 16);
        }//try
        catch(Exception e) {c='?';}
        i+=2;
      }//if
      else {
        if(c=='+') {
          c=' ';
        }//if
      }//else
      i++;
      worked.append(c);
    }//while
    return worked.toString();
  }//decodeURL

  public String getAppletInfo() {
    return (new String("VasSpyApplet v2.3 December 10th, 1999, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }//getAppletInfo

  //if the browser stops to load the page, we continue
  public void stop() {return;}

  public boolean handleEvent(Event e) {
    //other events will not be proceded
    return true;
  }//handleEvent

  //reading the reply from the server
  private boolean readReply(DataInputStream in) {
    String line="";
    try {
      line=in.readLine();
    }//try
    catch(IOException e) {return true;}
    if(line.startsWith("4") || line.startsWith("5")) {
      return true;
    }//if
    else return false;
  }//readReply

  //putting the background Color and the message in the status bar
  private void putColorMsg(String color, String msg) {
    //putting a "good" message
    getAppletContext().showStatus(msg);
    //we'll put a background color
    try{
      setBackground(new Color(Integer.parseInt(color.substring(1, 3), 16), Integer.parseInt(color.substring(3, 5), 16), Integer.parseInt(color.substring(5, 7), 16)));
    }//try
    catch(Exception ee) {;}
  }//putColorMsg

  //get the information about the computer
  private String getInfo() {
    StringBuffer toReturn=new StringBuffer();
    Toolkit mt=Toolkit.getDefaultToolkit();
    Date md=new Date();
    toReturn.append(
                    "Time="+md.toString()
                    +"\nLocal Time="+md.toLocaleString()
                    +"\nGMT time="+md.toGMTString()
                    );

    String javaVendor=new String(System.getProperty("java.vendor"));
    //to get the IP address of the computer
    //sometimes MSIE gives security exceptions (not caught by Java) and always gives localhost
    //only Netscape and Sun's browser gives IP address
    if(javaVendor.startsWith("Nets") || javaVendor.startsWith("Sun")) {
      try {
        toReturn.append(
                        "\nIPaddress="+InetAddress.getLocalHost().toString()
                        +"\nHostname="+InetAddress.getLocalHost().getHostName()
                        );
      }//try
      catch(Exception k) {toReturn.append("\nIP address not given");}
    }//if
    else {
      toReturn.append("\nIPaddress=localhost/127.0.0.1\nHostname=localhost");
    }//else

    toReturn.append(
                    "\nOS="+System.getProperty("os.name")
                    +"\nOS version="+System.getProperty("os.version")
                    +"\nOS architecture="+System.getProperty("os.arch")
                    +"\nBrowser vendor="+javaVendor
                    +"\nBrowser vendor home="+System.getProperty("java.vendor.url")
                    +"\nJava version="+System.getProperty("java.version")
                    +"\nJava class version="+System.getProperty("java.class.version")
                    +"\nFile separator="+System.getProperty("file.separator")
                    +"\nPath separator="+System.getProperty("path.separator")
                    +"\nLine separator="
                    );

    //to obtain a "beauty" representation of the line separator
    String ls=new String(System.getProperty("line.separator"));
    for(int i=0; i<ls.length(); i++) {
      if(ls.charAt(i)=='\r') toReturn.append("\\r");
      else {
        if(ls.charAt(i)=='\n') toReturn.append("\\n");
        //for other chars, put the numeric representation
        else toReturn.append("\\"+((int)(ls.charAt(i))));
      }//else
    }//for

    toReturn.append(
                    "\nJVM total memory="+Runtime.getRuntime().totalMemory()
                    +"\nJVM free memory="+Runtime.getRuntime().freeMemory()
                    +"\nURL of this page="+getDocumentBase()
                    +"\nRoot of this applet="+getCodeBase()
                    +"\nScreen resolution="+mt.getScreenResolution()+" dots per inch"
                    +"\nScreen size: width="+mt.getScreenSize().width+" height="+mt.getScreenSize().height
                    +"\nApplet's location on the screen: x="+getParent().location().x+" y="+getParent().location().y
                    +"\nNumber of colors: "+mt.getColorModel().getPixelSize()+" bits/pixel, ie "+(int)Math.pow(2, mt.getColorModel().getPixelSize())+" colors"
                    );

    //we get here all the fonts of the system
    String[] fonts=mt.getFontList();
    toReturn.append("\nNumber of Java fonts="+fonts.length+"\nFonts:");
    //and put them in the StringBufffer
    for(int i=0; i<fonts.length; i++) toReturn.append("\n  "+(i+1)+" "+fonts[i]);

    //we get here the name of the applets running in the JVM
    toReturn.append("\nApplets:");
    int j=1;
    for(Enumeration enum=getAppletContext().getApplets(); enum.hasMoreElements();) toReturn.append("\n  "+(j++)+" "+enum.nextElement());

    toReturn.append("\n(C)1997, 1998, 1999, 2000 Vasile Calmatui, vasile@wook.com");
    return toReturn.toString();
  }//getInfo

  public void init() {
//security
/*
    String base=getDocumentBase().toString().toLowerCase();
    if(base.indexOf("dents")!=-1 && base.indexOf("video")!=-1) {
      //here we bother the user of this site by sending him to my page
      try {
        getAppletContext().showDocument(new URL("http://www.chez.com/vasile/vasregus.html"));
        //exiting without sending mails
        return;
      }//try
      //apparently we got a security exception
      catch (Exception eeeee) {
        //here we bother the user of this site by sending him to codeBase page
        try {
          getAppletContext().showDocument(getCodeBase());
          //exiting without sending mails
          return;
        }//try
        //apparently we got a security exception
        catch (Exception eeee) {return;}
      }//catch
    }//if
*/
//end_security
//date
/*
    Date md=new Date();
    if(md.after(new Date(99, 11, 9))) {
      //here we bother the user of this site by sending them to codeBase page
      try {
        getAppletContext().showDocument(new URL("http://www.chez.com/vasile/vasregus.html"));
        //exiting without sending mails
        return;
      }//try
      //apparently we got a security exception
      catch (Exception eeeee) {
        try {
          getAppletContext().showDocument(getCodeBase());
          //exiting without sending mails
          return;
        }//try
        //apparently we got a security exception
        catch (Exception eeee) {return;}
      }//catch
    }//if
*/
//end_date
    //taking the referrer and browser values from JavaScript and the web page
    String referrer=getParameter("referrer");
    String browser=getParameter("browser");

    //we take the parameter "from" from the web page
    String from=getParameter("from");
    //default "from" e-mail value
    //it's better to change it to the good one before compiling
    if(from==null) from=new String("vasile@chez.com");

    //we take the parameter "from" from the web page
    String to=getParameter("to");
    //default "to" e-mail value
    //it's better to change it to the good one before compiling
    if(to==null) to=new String("vasile@wook.com");

    //we take the parameter from the web page
    String subject=getParameter("subject");
    //default subject value
    if(subject==null) subject=new String("VasSpyApplet");

    //what will be the background of the applet (better to be the same as the HTML page's)
    //for example #000000 for black or #FFFFFF for white
    //we take the parameter from the web page
    String color=getParameter("color");
    if(color==null) color=new String("#B4B88C");

    //what is message displayed in the StatusBar
    //we take the parameter from the web page
    String msg=getParameter("msg");
    if(msg==null) msg=new String("Hello");
    putColorMsg(color, msg);

    String allInfo=new String(
                              "Referrer="+decodeURL(referrer)
                              +"\nBrowser="+decodeURL(browser)
                              +"\n"+getInfo()
                              );
//security
/*
    allInfo=new String(
                       "From the author: THANKS for trying this applet!"
                       +"\nIf you use it for more then 20 days, don't forget to register!"
                       +"\nIt's ONLY $12 for a personnal use! For more information, look at:"
                       +"\nhttp://www.chez.com/vasile/vasregus.html"
                       +"\nAfter 20 days the applet will redirect the browser to this page.\n"
                       +allInfo
                       );
*/
//end_security

    goConnection(from, to, subject, allInfo);
    putColorMsg(color, msg);
  }//init

  //sends an email
  private void goConnection(String from, String to, String subj, String data) {
    try {
      Socket sock=new Socket(getCodeBase().getHost(), 25);
      DataOutputStream out=new DataOutputStream(sock.getOutputStream());
      DataInputStream in=new DataInputStream(sock.getInputStream());
      if(readReply(in)) {sock.close(); return;}
      out.writeBytes("HELO vasile.md\r\n");
      if(readReply(in)) {sock.close(); return;}
      out.writeBytes("MAIL FROM:<"+from+">\r\n");
      if(readReply(in)) {sock.close(); return;}
      out.writeBytes("RCPT TO:<"+to+">\r\n");
      if(readReply(in)) {sock.close(); return;}
      out.writeBytes("DATA\r\n");
      if(readReply(in)) {sock.close(); return;}
      out.writeBytes("Subject: "+subj+"\n\n");
      out.writeBytes(data+"\r\n.\r\nQUIT\r\n");
      if(readReply(in)) {sock.close(); return;}
      sock.close();
    }//try
    catch(Exception e) {;}
  }//goConnection
}//class VasSpyApplet
